"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = void 0;
exports.Pill = Pill;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * Primary UI component for user interaction
 */
var BaseButton = _styledComponents.default.button(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  /* Adapt the colors based on primary prop */\n  height: fit-content;\n  max-height: 150px;\n  width: fit-content;\n  max-width: 300px;\n  background: ", ";\n  color: ", ";\n  font-size: 1em;\n  margin: 1em;\n  padding: 0.25em 1em;\n  border: 2px solid var(--primary);\n  border-radius: 3px;\n  &:active {\n    transition: all 180ms ease-in-out;\n    background: ", ";\n    color: ", ";\n  }\n  &:hover {\n    transition: all 180ms linear;\n  }\n"])), function (props) {
  return props.primary ? "var(--primary)" : "var(--light)";
}, function (props) {
  return props.primary ? "var(--light)" : "var(--primary)";
}, function (props) {
  return props.primary ? "var(--light)" : "var(--primary)";
}, function (props) {
  return props.primary ? "var(--primary)" : "var(--light)";
});

BaseButton.propTypes = {
  label: _propTypes.default.string.isRequired,
  primary: _propTypes.default.bool,
  onClick: _propTypes.default.func
};
BaseButton.defaultProps = {
  primary: false,
  onClick: undefined
};

var Button = function Button(props) {
  return /*#__PURE__*/_react.default.createElement(BaseButton, props, props.label);
};

exports.Button = Button;
Button.propTypes = {
  label: _propTypes.default.string.isRequired,
  onClick: _propTypes.default.func,
  primary: _propTypes.default.bool
};
var BasePill = (0, _styledComponents.default)(_reactRouterDom.Link)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  display: inline-block;\n  height: fit-content;\n  max-height: 150px;\n  width: fit-content;\n  max-width: 300px;\n  border-radius: 3px;\n  padding: 3px;\n  margin: 3px;\n  width: 5rem;\n  background: ", ";\n  color: ", ";\n  border: ", ";\n  border-radius: 32px;\n  font-size: 12px;\n  text-align: center;\n  text-decoration: none;\n  &:active {\n    transition: all 180ms ease-in-out;\n    background: ", ";\n    color: ", ";\n    border: ", ";\n   }\n  &:visited {\n    transition: all 180ms ease-in-out;\n    background: ", ";\n    color: ", ";\n   }\n  &:hover {\n    background: ", ";\n    color: ", ";\n    border: ", ";\n  }\n"])), function (props) {
  return props.selected ? "var(--primary)" : "var(--light)";
}, function (props) {
  return props.selected ? "var(--light)" : "var(--primary)";
}, function (props) {
  return props.selected ? "thin solid var(--light)" : "thin solid var(--primary)";
}, function (props) {
  return props.selected ? "var(--primary)" : "var(--light)";
}, function (props) {
  return props.selected ? "var(--light)" : "var(--primary)";
}, function (props) {
  return props.selected ? "thin solid var(--light)" : "thin solid var(--primary)";
}, function (props) {
  return props.selected ? "var(--primary)" : "var(--light)";
}, function (props) {
  return props.selected ? "var(--light)" : "var(--primary)";
}, function (props) {
  return props.selected ? "var(--light)" : "var(--primary)";
}, function (props) {
  return props.selected ? "var(--primary)" : "var(--light)";
}, function (props) {
  return props.selected ? "thin solid var(--light)" : "thin solid var(--primary)";
});

function Pill(props) {
  console.log(props);
  return /*#__PURE__*/_react.default.createElement(BasePill, {
    id: props.id,
    onClick: props.onClick,
    to: props.itemType ? "".concat(props.itemType, ",").concat(props.id) : "".concat(props.to),
    selected: props.selected
  }, props.children);
}

Pill.propTypes = {
  id: _propTypes.default.any.isRequired,
  itemType: _propTypes.default.any,
  onClick: _propTypes.default.func,
  selected: _propTypes.default.bool,
  to: _propTypes.default.string
};
Pill.defaultProps = {
  onClick: undefined,
  selected: false
};