"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Calendar;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var CalendarGrid = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  display: grid;\n  grid-template-columns: repeat(7, 1fr);\n"])));

var DateGrid = (0, _styledComponents.default)(CalendarGrid)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  margin-top: 0.5em;\n  border: 0.5px solid var(--blue-grey-200);\n  //border-bottom: 1px solid var(--blue-grey-200);\n  \n  /* Positioning the first day */\n  div:first-child {\n    grid-column: 6;\n  }\n\n  // Style for each day\n  div {\n    grid-auto-rows: 100px;\n    text-align: right;\n    position: relative;\n    border: 0.5px solid var(--blue-grey-200);\n    //border-top: 1px solid var(--blue-grey-200);\n    width: 4.5ch;\n    height: 4.5ch;\n    background-color: transparent;\n    color: var(--blue-grey-600);\n  }\n\n  div:hover,\n  div:focus {\n    outline: none;\n    background-color: var(--blue-grey-050);\n    color: var(--blue-grey-700);\n  }\n\n  div:active,\n  div.is-selected {\n    background-color: var(--teal-100);\n    color: var(--teal-900);\n  }\n\n"])));
var DayOfWeek = (0, _styledComponents.default)(CalendarGrid)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  margin-top: 1.25em;\n  > * {\n    font-size: 0.7em;\n    color: var(--blue-grey-400);\n    font-weight: 500;\n    letter-spacing: 0.1em;\n    font-variant: small-caps;\n    text-align: center;\n  }  \n"])));

var MonthIndicator = _styledComponents.default.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  color: var(--blue-grey-700);\n  text-align: center;\n  font-weight: 500;\n"])));

function getFirstOfMonth(year, month) {
  return new Date(year, month).getDay();
}

function getLastOfMonth(year, month) {
  return 32 - new Date(year, month, 32).getDate();
}

function getCurrent() {
  var date = new Date();
  return {
    year: date.getFullYear(),
    month: date.getMonth(),
    day: date.getDate(),
    first: getFirstOfMonth(date.getFullYear(), date.getMonth()),
    last: getLastOfMonth(date.getFullYear(), date.getMonth()),
    date: date.toLocaleDateString()
  };
}

var CalendarWrapper = _styledComponents.default.div(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  max-width: max-content;\n  margin: 3em auto 0 auto;\n  padding: 1.5em;\n  background-color: #fff;\n  border: 2px solid var(--blue-grey-200);\n  border-radius: 8px;\n}\n"])));

var Days = function Days(props) {
  var a = [];

  for (var i = props.current.first; i <= props.current.last; i++) {
    a.push(i);
  }

  return a.map(function (item) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: item
    }, /*#__PURE__*/_react.default.createElement("time", {
      dateTime: "".concat(props.current.year, "-").concat(props.current.month, "-").concat(item)
    }, item));
  });
};

function Calendar() {
  var _useState = (0, _react.useState)(getCurrent()),
      _useState2 = _slicedToArray(_useState, 2),
      currentDate = _useState2[0],
      setCurrentDate = _useState2[1];

  return /*#__PURE__*/_react.default.createElement(CalendarWrapper, null, /*#__PURE__*/_react.default.createElement(MonthIndicator, null, /*#__PURE__*/_react.default.createElement("time", {
    dateTime: "".concat(currentDate.year, "-").concat(currentDate.month)
  }, "".concat(currentDate.year, " ").concat(currentDate.month))), /*#__PURE__*/_react.default.createElement(DayOfWeek, null, /*#__PURE__*/_react.default.createElement("div", null, "Su"), /*#__PURE__*/_react.default.createElement("div", null, "Mo"), /*#__PURE__*/_react.default.createElement("div", null, "Tu"), /*#__PURE__*/_react.default.createElement("div", null, "We"), /*#__PURE__*/_react.default.createElement("div", null, "Th"), /*#__PURE__*/_react.default.createElement("div", null, "Fr"), /*#__PURE__*/_react.default.createElement("div", null, "Sa")), /*#__PURE__*/_react.default.createElement(DateGrid, null, /*#__PURE__*/_react.default.createElement(Days, {
    current: currentDate
  })));
}