"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Carousel;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _templateObject, _templateObject2, _templateObject3;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Slider = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    z-index: 300;\n    width: 100%;\n    max-width: 800px;\n    height: 350px;\n    position: relative;\n    overflow: hidden;\n    border-radius: 36px;"])));

var Slide = _styledComponents.default.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    width: 100%;\n    max-width: 800px;\n    height: 350px;\n    position: absolute;\n    transition: all 0.5s;\n    img {\n        width: 100%;\n        height: 100%;\n        object-fit: cover;\n    }\n"])));

var CarouselButton = _styledComponents.default.button(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    position: absolute;\n    width: 40px;\n    height: 40px;\n    padding: 10px;\n    border: none;\n    border-radius: 50%;\n    z-index: 10px;\n    cursor: pointer;\n    background-color: #fff;\n    font-size: 18px;\n    ", "\n    &:active {\n        transform: scale(1.1);\n    }\n    &:hover {\n        transform: scale(1.1);\n    }\n"])), function (props) {
  return "\n        ".concat(props.direction === 'left' ? "\n        top: 45%;\n        left: 2%;\n        " : "\n        top: 45%;\n        right: 2%;\n        ", "\n    ");
});

function Carousel(props) {
  var _useState = (0, _react.useState)({
    currentSlide: 0
  }),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  (0, _react.useEffect)(function () {
    document.onkeydown = keyHandler;
  });
  var slideCount = props.items.length - 1;

  var nextHandler = function nextHandler() {
    if (state.currentSlide === slideCount) {
      setState(_objectSpread(_objectSpread({}, state), {
        currentSlide: 0
      }));
    } else {
      setState(_objectSpread(_objectSpread({}, state), {
        currentSlide: state.currentSlide + 1
      }));
    }
  };

  var keyHandler = function keyHandler(e) {
    e = e || window.event;

    switch (e.code) {
      case 'ArrowRight':
        // next, right arrow
        nextHandler();
        break;

      case 'ArrowLeft':
        // prev, left arrow
        prevHandler();
        break;

      default:
        break;
    }
  };

  var prevHandler = function prevHandler() {
    if (state.currentSlide === 0) {
      setState(_objectSpread(_objectSpread({}, state), {
        currentSlide: slideCount
      }));
    } else {
      setState(_objectSpread(_objectSpread({}, state), {
        currentSlide: state.currentSlide - 1
      }));
    }
  };

  return /*#__PURE__*/_react.default.createElement(Slider, null, props.items.map(function (photo, idx) {
    return /*#__PURE__*/_react.default.createElement(Slide, {
      key: photo.id,
      style: {
        transform: "translateX(".concat(100 * (idx - state.currentSlide), "%)")
      }
    }, /*#__PURE__*/_react.default.createElement("img", {
      id: idx,
      key: idx,
      src: photo.src,
      alt: photo.alt
    }));
  }), /*#__PURE__*/_react.default.createElement(CarouselButton, {
    direction: "right",
    onClick: nextHandler
  }, '>'), /*#__PURE__*/_react.default.createElement(CarouselButton, {
    direction: "left",
    onClick: prevHandler
  }, '<'));
}

Carousel.propTypes = {
  items: _propTypes.default.array.isRequired
};