"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Row = exports.Grid = exports.Col = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _templateObject, _templateObject2, _templateObject3;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Grid = _styledComponents.default.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n    ", "\n    ", "\n"])), function (props) {
  return props.fontFamily ? "font-family: ".concat(props.fontFamily, ";") : null;
}, function (props) {
  return props.background ? "background: ".concat(props.background, ";") : null;
});

exports.Grid = Grid;
Grid.propTypes = {
  background: _propTypes.default.string,
  fontFamily: _propTypes.default.string
};
Grid.defaultProps = {
  background: 'var(--light)',
  fontFamily: "verdana, san-serif"
};

var Row = _styledComponents.default.div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n    display: flex;\n    ", "\n    ", "\n    ", ";\n"])), function (props) {
  return props.background ? "background: ".concat(props.background, ";") : "color: inherit;";
}, function (props) {
  return props.color ? "color: ".concat(props.color, ";") : "color: inherit;";
}, function (props) {
  return "\n                ".concat(props.hoverColor ? "&:hover {\n                    background: ".concat(props.hoverColor, ";\n                    transition: all 180ms ease-in-out;") : null, "\n            ");
});

exports.Row = Row;
var commonDefaults = {
  border: 'thin dashed var(--dark)',
  justify: 'left',
  align: 'left',
  collapse: false
};
Row.propTypes = {
  background: _propTypes.default.string,
  color: _propTypes.default.string,
  hoverColor: _propTypes.default.string,
  border: _propTypes.default.string,
  justify: _propTypes.default.string,
  align: _propTypes.default.string,
  collapse: _propTypes.default.bool
};
Row.defaultProps = commonDefaults;
var media = {
  xs: function xs(styles) {
    return "\n    @media only screen and (max-width: 480px) {\n        ".concat(styles, "\n    }");
  }
};

var Col = _styledComponents.default.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n    display: flex;\n    flex: ", ";\n    ", "\n    ", "\n    ", "\n    ", ";\n    ", "\n    ", "\n"])), function (props) {
  return props.size;
}, function (props) {
  return props.background ? "background: ".concat(props.background, ";") : "color: inherit;";
}, function (props) {
  return props.border ? "border: ".concat(props.border, ";") : null;
}, function (props) {
  return props.color ? "color: ".concat(props.color, ";") : "color: inherit;";
}, function (props) {
  return "\n                ".concat(props.hoverColor ? "&:hover {\n                    background: ".concat(props.hoverColor, ";\n                    transition: all 180ms ease-in-out;") : null, "\n            ");
}, function (props) {
  return props.justify ? "justify-content: ".concat(props.justify, ";") : null;
}, function (props) {
  return props.collapse && media[props.collapse]("\n        display: none;\n        text-align: ".concat(props.align, ";\n        "));
});

exports.Col = Col;
Col.propTypes = {
  background: _propTypes.default.string,
  color: _propTypes.default.string,
  hoverColor: _propTypes.default.string,
  border: _propTypes.default.string,
  justify: _propTypes.default.string,
  align: _propTypes.default.string,
  collapse: _propTypes.default.bool
};
Col.defaultProps = commonDefaults;